publish_npm:
  stage: publish_npm

  image: node:14

  script:
    - apt-get update
    - apt-get install build-essential libcairo2-dev libpango1.0-dev libjpeg-dev libgif-dev librsvg2-dev curl jq -y
    - cd $NPM_MODULE_DIR
    # Commented out, because API access not possible from CI right now
    #- packages=$( curl -s -X GET "https://gitlab.com/api/v4/groups/4873250/packages?private_token=${API_TOKEN}" )
    #- echo $packages
    - >
      for dir in $(ls -d */ | sed 's#/##'); do
        cd $dir
        echo $dir

        # versionOnline=$( echo $packages | jq -r '.[] | select (.name == "@apmatic/'$dir'") | .version' )
        # versionLocal=$( jq -r .version package.json )

        # if [ $versionOnline != $versionLocal ]
        # then
        echo "@apmatic:registry=https://gitlab.com/api/v4/projects/${CI_PROJECT_ID}/packages/npm/">.npmrc
        echo "//gitlab.com/api/v4/projects/${CI_PROJECT_ID}/packages/npm/:_authToken=${CI_JOB_TOKEN}">>.npmrc
        cat .npmrc
        echo "--- Config ---"
        npm config set unsafe-perm true
        echo "--- Install ---"
        npm install --build-from-source
        echo "--- Build ---"
        npm run build
        echo "--- Publish ---"
        if npm publish ; then
          echo "SUCCESS"
        else
          echo "FAIL"
        fi
        # else
        #   echo "version already exists"
        # fi
        cd ..
      done
